clear all;

if exist('graphics_toolkit','file')
  graphics_toolkit('fltk')
end

A   = [4 1.5; 1.5 3];
b   = [1; 2];
f   = @(x) x + (x > 1) .* (x - 1);
phi = @(x) f(norm(x,2));
J   = @(x) .5*dot(A*x,x) - dot(b,x) + phi(x);

scale = 10.0;

t = -5:0.1:5;
x = scale*cos(t);
y = scale*sin(t);
z = arrayfun(@(vec1, vec2) J([vec1; vec2]), x, y);

hold on
plot3(x,y,z,'k');

title 'scale = 10'

# Minima taken from test-circle.cc

line([-5.3444 6.36022],
     [8.45206 -7.71671],
     [J([-5.3444; 8.45206]) J([6.36022; -7.71671])])

x = scale * (-1:.05:1);
y = scale * (-1:.05:1);
[X, Y] = meshgrid(x,y);

for i=1:length(y)
  val(i,:) = arrayfun(@(vec1, vec2) J([vec1; vec2]), X(i,:), Y(i,:));
end

surf(x, y, val)
hold off;
