#ifndef DIM
#error DIM unset
#endif

#include <dune/common/fmatrix.hh>
#include <dune/common/fvector.hh>
#include <dune/grid/alugrid.hh>
#include <dune/istl/bvector.hh>

#include <dune/fufem/functionspacebases/p0basis.hh>
#include <dune/fufem/functionspacebases/p1nodalbasis.hh>

typedef Dune::BlockVector<Dune::FieldVector<double, 1>> SingletonVectorType;

typedef Dune::FieldVector<double, DIM> SmallVector;
typedef Dune::FieldMatrix<double, DIM, DIM> SmallMatrix;
typedef Dune::BlockVector<SmallVector> VectorType;

typedef Dune::ALUGrid<DIM, DIM, Dune::simplex, Dune::nonconforming> GridType;
typedef GridType::LeafGridView GridView;
typedef P1NodalBasis<GridView, double> P1Basis;
typedef P0Basis<GridView, double> MyP0Basis;

template void writeVtk<P1Basis, MyP0Basis, VectorType, SingletonVectorType,
                       GridView>(P1Basis vertexBasis, VectorType displacement,
                                 SingletonVectorType state, MyP0Basis cellBasis,
                                 SingletonVectorType stress, GridView gridView,
                                 std::string filename);
